/*
 * demo.c
 *
 * Last modified: <2014/12/07 16:41:16 +0900> By @MIRROR_
 */
#include "nes.h"
#include "game.h"
#include "map.h"

const unsigned char playdemo_scene01_1p[] = {
/* 1000: */ 0x00,0x29,0x04,0x3f,0x00,0x17,0x01,0x2b,0x00,0x14,0x04,0x06,0x00,0x22,0x80,0x08,
/* 1010: */ 0x00,0x25,0x40,0x04,0x00,0x1a,0x02,0x27,0x00,0x1a,0x08,0x49,0x00,0x21,0x80,0x0a,
/* 1020: */ 0x00,0x45,0x40,0x08,0x00,0x10,0x01,0x0f,0x00,0x13,0x04,0x08,0x00,0x36,0x80,0x07,
/* 1030: */ 0x00,0x42,0x40,0x07,0x00,0x13,0x02,0x0f,0x00,0x10,0x08,0x08,0x00,0x24,0x80,0x06,
/* 1040: */ 0x00,0x30,0x40,0x08,0x00,0x0c,0x01,0x0a,0x00,0x18,0x04,0x05,0x00,0x29,0x80,0x07,
/* 1050: */ 0x00,0x32,0x40,0x08,0x00,0x11,0x02,0x0a,0x00,0x12,0x08,0x08,0x00,0x1f,0x80,0x08,
/* 1060: */ 0x00,0x45,0x40,0x07,0x00,0x18,0x02,0x42,0x00,0x12,0x04,0x0b,0x00,0x0a,0x01,0x0a,
/* 1070: */ 0x00,0x23,0x80,0x07,0x00,0x5b,0x40,0x07,0x00,0x06,0x01,0x42,0x00,0x0f,0x08,0x09,
/* 1080: */ 0x00,0x19,0x80,0x08,0x00,0x32,0x08,0x09,0x00,0x19,0x02,0x04,0x00,0x47,0x80,0x07,
/* 1090: */ 0x00,0x26,0x80,0x09,0x00,0x76,0x04,0x0a,0x00,0x49,0x40,0x0b,0x00,0x18,0x01,0x0c,
/* 10a0: */ 0x00,0x2e,0x80,0x05,0x00,0x03,0xff,0xff,
};
const unsigned char playdemo_scene01_2p[] = {
	0xff,0xff,
};

typedef struct PlayDemoInfo {
	const unsigned char* recdat;
	unsigned char pad;
	unsigned char cnt;
} PlayDemoInfo;

PlayDemoInfo pdi[PLAYER_MAX];

void __fastcall__ demo_init(void) {

	// ϐ
	pdi[0].recdat = playdemo_scene01_1p;
	pdi[0].pad = *pdi[0].recdat++;
	pdi[0].cnt = *pdi[0].recdat++;

	pdi[1].recdat = playdemo_scene01_2p;
	pdi[1].pad = *pdi[1].recdat++;
	pdi[1].cnt = *pdi[1].recdat++;

	// }bv
	map_init(0);
}

char __fastcall__ demo_sync(void) {
	unsigned char i, j;
	unsigned char p, c;
	unsigned char ret;
	unsigned char inp = 0;

	*JOYPAD = 1;
	*JOYPAD = 0;
	padother= 0;

	// pbh͂
	for(i = 0; i < 2; i++) {
		c = 0;
		for(j = 0; j < 8; j++) {
			ret = *(JOYPAD + i);
			c <<= 1;
			c |= ret & 0x01;
			padother |= ret & 0x0f;
		}

		if (c & BTN_START) {
			return 1;
		}

		if (game.task == GAME_TASK_PLAY) {
			p = padinfo[i][BTN_STAT_PRESS];
			c = pdi[i].pad;

			if (c == 0xff) {
				c = 0;
			} else if (--pdi[i].cnt == 0) {
				pdi[i].pad = *pdi[i].recdat++;
				pdi[i].cnt = *pdi[i].recdat++;
			}

			padinfo[i][BTN_STAT_PRESS] =  c;
			padinfo[i][BTN_STAT_DOWN ] =  c & ~p;
			padinfo[i][BTN_STAT_UP   ] = ~c &  p;
		}
	}

	return 0;
}
