/*
 * map.h
 *
 * Last modified: <2014/12/01 20:38:13 +0900> By @MIRROR_
 */
#ifndef MAP_H_INCLUDED
#define MAP_H_INCLUDED

#define BG_FIELD_W  (BG_NAMTBL_W/2)
#define BG_FIELD_H  (BG_NAMTBL_H/2)
#define MAP_FIELD_W 12
#define MAP_FIELD_H 11
#define MAP_NAMTBL_W (MAP_FIELD_W*2)
#define MAP_NAMTBL_H (MAP_FIELD_H*2)

#define MAP_SYNBOL(chr, mcp) (((chr+1) << 4)|(mcp))
#define GET_CHAR_ID(m)       ((((m) >> 4)-1) & 0x0f)
#define GET_CHIP_ID(m)       ((m) & 0x07)
#define MAP_CHAR_NO(no)      (((no)+1) << 4)
#define REMOVE_CHIP(m)       ((m) & 0xf0)
#define REMOVE_CHAR(m)       ((m) & 0x0f)

// }bv`bvID
enum {
	MCP_FIELD = 0,
	MCP_BALL,
	MCP_GOAL,
	MCP_ICECUBE,
	MCP_BLOCK,
	MCP_FBLOCK,
	MCP_WALL,
	MCP_MAX,
	MCP_FLAG_MOVE = 0x08
};

// }bv`bv
extern const unsigned char mapchips[][4];

// BGe[u
extern const unsigned char attrbg[];

// Q[̃}bv
extern unsigned char gamemap[MAP_FIELD_H][MAP_FIELD_W];

// e[u
extern unsigned char attrtbl[BG_ATTR_H][BG_ATTR_W];

// }bv̏
extern void map_init(char scene);

// wW̃}bv擾
#define  map_getmcp(x, y, mcp) \
	mcp = (MAP_FIELD_W <= x || MAP_FIELD_H <= y)? MCP_WALL: gamemap[y][x];


// wW̃}bvݒ
#define map_setmcp(x, y, mcp) \
	gamemap[y][x] = mcp;

extern void map_set(unsigned char x, unsigned char y, unsigned char mcp);
extern unsigned char map_move(unsigned char x, unsigned char y, unsigned char dir);

#endif
